Subject: [tsvwg] SCTP question

From: <[email-masked]>
Date: Tue, 16 Oct 2018 14:42:05 +0000

A colleague of mine, Perry, has a couple of questions about SCTP RFC4960. He's in the BT design team on Signalling protocols and concerned about conformance testing amongst other issues.

The statement is on page 57 of RFC4960  (section on Association initialisation) "Note: T1-init timer and T1-cookie timer shall follow the same rules given in Section 6.3."
The question is: how should the "shall" be interpreted in this sentence? Does it mean that the S6.3 rules MUST be followed? Or does it mean that the S6.3 rules are optional - in which case, are there any thoughts about rules other than those in S6.3?

Thanks,
Best wishes,
Philip Eardley
Research and Innovation
This email contains BT information, which may be privileged or confidential. It's meant only for the individual(s) or entity named above. If you're not the intended recipient, note that disclosing, copying, distributing or using this information is prohibited. If you've received this email in error, please let me know immediately on the email address above. Thank you.
We monitor our email system, and may record your emails.
British Telecommunications plc
Registered office: 81 Newgate Street London EC1A 7AJ
Registered in England no: 1800000

---

From: Neil Horman <[email-masked]>
Date: Tue, 16 Oct 2018 13:36:20 -0400

> The question is: how should the "shall" be interpreted in this sentence? Does it mean that the S6.3 rules MUST be followed? Or does it mean that the S6.3 rules are optional - in which case, are the…
The conventions section indicates that they keyword SHALL is goverened by
RFC2119, which asserts SHALL is synonomous with the keywork MUST.  That is to
say that the phrase above on page 57 of RFC4960 is an absolute requirement.  You
have to have the T1-init and T1-cookie timer follow the same rules given in
Section 6.3

Neil

> Thanks,
> Best wishes,
> Philip Eardley
> Research and Innovation
> This email contains BT information, which may be privileged or confidential.. It's meant only for the individual(s) or entity named above. If you're not the intended recipient, note that disclosing, copying, distributing or using this information is prohibited. If you've received this email in error, please let me know immediately on the email address above. Thank you.

---

From: "Proshin, Maksim" <[email-masked]>
Date: Wed, 17 Oct 2018 08:32:04 +0000

Hi Neil,

In general it's not correct to say that "shall" is the same as SHALL. Thus RFC 8174 explains that 
"only UPPERCASE usage of the key words have the defined special meanings".
Saying this anyway I think that RFC 4960 actually means SHALL/MUST in that note.  

BR, Maxim

-----Original Message-----
From: tsvwg [mailto:[email-masked]] On Behalf Of Neil Horman
Sent: Tuesday, October 16, 2018 20:36
To: [email-masked]
Cc: [email-masked]; [email-masked]
Subject: Re: [tsvwg] SCTP question

> The question is: how should the "shall" be interpreted in this sentence? Does it mean that the S6.3 rules MUST be followed? Or does it mean that the S6.3 rules are optional - in which case, are the…
The conventions section indicates that they keyword SHALL is goverened by RFC2119, which asserts SHALL is synonomous with the keywork MUST.  That is to say that the phrase above on page 57 of RFC4960 is an absolute requirement.  You have to have the T1-init and T1-cookie timer follow the same rules given in Section 6.3

Neil

> Registered office: 81 Newgate Street London EC1A 7AJ Registered in 
> England no: 1800000
>

---

From: <[email-masked]>
Date: Mon, 22 Oct 2018 10:01:09 +0000

Do other people agree?- especially Randall, as editor of RFC4960, and other people who've been involved a lot with SCTP?
Thanks
phil

-----Original Message-----
From: Proshin, Maksim [mailto:[email-masked]] 
Sent: 17 October 2018 09:32
To: Neil Horman <[email-masked]>; Eardley,PL,Philip,TUD1 R <[email-masked]>
Cc: Wilks,PB,Perry,TLB35 R <[email-masked]>; [email-masked]
Subject: RE: [tsvwg] SCTP question

Hi Neil,

In general it's not correct to say that "shall" is the same as SHALL. Thus RFC 8174 explains that "only UPPERCASE usage of the key words have the defined special meanings".
Saying this anyway I think that RFC 4960 actually means SHALL/MUST in that note.  

BR, Maxim

-----Original Message-----
From: tsvwg [mailto:[email-masked]] On Behalf Of Neil Horman
Sent: Tuesday, October 16, 2018 20:36
To: [email-masked]
Cc: [email-masked]; [email-masked]
Subject: Re: [tsvwg] SCTP question

Neil

---

From: Michael Tuexen <[email-masked]>
Date: Mon, 22 Oct 2018 22:31:51 +0200

> On 22. Oct 2018, at 12:01, [email-masked] wrote:
> 
I agree with the other people... I interpret it as a SHALL.

When doing conformance testing (which I do once in a while), I expect the INITs and COOKIE-ECHOs to be retransmitted
based on the timer rules (Start with RTO.Initial, double until reaching RTO.Max). If the peer is multihomed and this
is configured, one has to consider if the multiple address are used for retransmitting the INITs and COOKIE-ECHOs.

I know that the use of shall sometimes causes confusion and we will likely resolve this when working on RFC 4960bis.

You can forward my address to your colleague in case he has further questions. I wrote two implementations of the
ETSI conformance test suite for SCTP:
* https://github.com/nplab/ETSI-SCTP-Conformance-Testsuite
  This is based on an extended version of packetdrill and can be used to test socket based
  implementations like the FreeBSD or Linux kernel implementation. Working on Solaris support.
* https://github.com/nplab/sctp-tests
  This can be used for blackbox testing and is based on the SCTP Test Tool stt.

Best regards
Michael

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 24 Oct 2018 08:54:19 -0600

Michael,

Michael Tuexen wrote:			    (Mon, 22 Oct 2018 22:31:51)
> I agree with the other people... I interpret it as a SHALL.

I interpreted it as SHALL as well.

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.com/

---

From: <[email-masked]>
Date: Wed, 31 Oct 2018 10:56:02 +0000

HI all,

Many thanks for your replies. What is the process for ensuring that this is documented?    

Perry Wilks 
BT Technology
Signalling Protocols Lead 
SDIN Architecture & Design Team 
TLB35
Email: [email-masked] 
Tel: 020-8726-2646
British Telecommunications plc 
Registered office: 81 Newgate Street London EC1A 7AJ 
Registered in England no. 1800000 
"This electronic message contains information from British Telecommunications plc which may be privileged or confidential. The information is intended to be for the use of the individual (s) or the entity named above. If you are not the intended recipient be aware that any disclosure, copying, distribution or use of the contents of this information is prohibited. If you have received this electronic message in error, please notify us by telephone or email (to the numbers or address above) immediately". 
Activity and use of the  British Telecommunications plc email system is monitored to secure its effective operation and for other lawful business purposes. Communications using this system will also be monitored and may be recorded to secure effective operation and for other lawful business purposes.

-----Original Message-----
From: Brian F. G. Bidulock [mailto:[email-masked]] 
Sent: 24 October 2018 15:54
To: Michael Tuexen
Cc: Eardley,PL,Philip,TUD1 R; Wilks,PB,Perry,TLB35 R; [email-masked]; [email-masked]
Subject: Re: [tsvwg] SCTP question

Michael,

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.com/

---

From: <[email-masked]>
Date: Wed, 31 Oct 2018 11:40:47 +0000

All,

Many thanks for your responses.

If possible I would like to get confirmation of our understanding.

Our understanding is (assuming that the 'shall' in the note should be uppercase) that the rules as for the DATA CHUNK are followed.

This means that there is a separate timer for each destination IP address.  The changeover to try a different IP address only takes place after X retransmissions to the same IP address. When X is reached a transmission to an alternative IP address is made.

Is our understanding correct?

Many thanks for your time.

Perry Wilks 
BT Technology

-----Original Message-----
From: Brian F. G. Bidulock [mailto:[email-masked]] 
Sent: 24 October 2018 15:54
To: Michael Tuexen
Cc: Eardley,PL,Philip,TUD1 R; Wilks,PB,Perry,TLB35 R; [email-masked]; [email-masked]
Subject: Re: [tsvwg] SCTP question

Michael,

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.com/